# Installation
> `npm install --save @types/react-avatar-editor`

# Summary
This package contains type definitions for react-avatar-editor (https://github.com/mosch/react-avatar-editor).

# Details
Files were exported from https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/react-avatar-editor.
## [index.d.ts](https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/react-avatar-editor/index.d.ts)
````ts
import * as React from "react";

declare namespace AvatarEditor {
    interface Position {
        x: number;
        y: number;
    }

    interface CroppedRect extends Position {
        width: number;
        height: number;
    }

    interface ImageState extends CroppedRect {
        resource: ImageData;
    }

    interface AvatarEditorProps {
        className?: string | undefined;
        image: string | File;
        width?: number | undefined;
        height?: number | undefined;
        backgroundColor?: string | undefined;
        border?: number | number[] | undefined;
        borderRadius?: number | undefined;
        color?: number[] | undefined;
        style?: object | undefined;
        scale?: number | undefined;
        position?: Position | undefined;
        rotate?: number | undefined;
        crossOrigin?: string | undefined;
        disableBoundaryChecks?: boolean | undefined;
        disableHiDPIScaling?: boolean | undefined;
        disableCanvasRotation?: boolean | undefined;
        onLoadFailure?(event: Event): void;
        onLoadSuccess?(imgInfo: ImageState): void;
        onImageReady?(event: Event): void;
        onMouseUp?(): void;
        onMouseMove?(event: Event): void;
        onImageChange?(): void;
        onPositionChange?(position: Position): void;
    }
}

declare class AvatarEditor extends React.Component<AvatarEditor.AvatarEditorProps, any> {
    getImage(): HTMLCanvasElement;
    getImageScaledToCanvas(): HTMLCanvasElement;
    getCroppingRect(): AvatarEditor.CroppedRect;
}

export = AvatarEditor;

````

### Additional Details
 * Last updated: Tue, 25 Feb 2025 00:03:48 GMT
 * Dependencies: [@types/react](https://npmjs.com/package/@types/react)

# Credits
These definitions were written by [Diogo Corrêa](https://github.com/diogocorrea), [Gabriel Prates](https://github.com/gabsprates), [Laurent Senta](https://github.com/lsenta), [David Spiess](https://github.com/davidspiess), and [John Grisham](https://github.com/JohnGrisham).
